﻿function JM_OnLoad()
	SlashCmdList["JEJEMOUNT"] = JM_Main;
	SLASH_JEJEMOUNT1 = "/jm";
	SLASH_JEJEMOUNT2 = "/jmount";
	SLASH_JEJEMOUNT3 = "/jejemount";
end

function JM_Main(msg)
	if msg == "" then
		JM_PrintUsage();
	else
		local landMount, flyingMount = JM_Parse(msg);
		if landMount==JM_SYNTAX_ERROR then
			print("Jeje|cff00ff00Mount|r syntax error.");
		else
			JM_Mount(landMount, flyingMount);
		end
	end
end

function JM_PrintUsage()
	print("------ Jeje|cff00ff00Mount|r v" .. JM_VERSION .. " ------");
	print("Usage : \n/jejemount <land mount number> <flying mount number>\n- You can also use /jm or /jmount.\n- You can use rand or rand(<numbers separated by commas>) instead of a mount number.");
	print("Examples : \n/jejemount 6 2\n/jejemount rand rand\n/jejemount rand(1,3,7) rand");
	print("---------------------------------");
end

function JM_Parse(msg)
	local arg1, arg2 = strmatch(msg, "(.+)%s(.+)");
	if arg1==nil or arg2==nil then return JM_SYNTAX_ERROR,nil;
	else
		arg1, arg2 = JM_ParseArg(arg1,false),JM_ParseArg(arg2,true);
		if arg1==nil or arg2==nil then return JM_SYNTAX_ERROR,nil;
		else return arg1, arg2;
		end
	end
end

function JM_ParseArg(arg, flyingMount)
	if tonumber(arg) ~= nil then return arg;
	elseif arg == "rand" then
		landMounts, flyingMounts = JM_ScanMounts();
		if flyingMount then return flyingMounts[math.random(#flyingMounts)];
		else return landMounts[math.random(#landMounts)];
		end
	else
		arg = strmatch(arg, "rand%((.+)%)");
		if arg ~= nil then
			local args = {};
			for number in string.gmatch(arg, "%s*(%d)%s*,?") do
				table.insert(args,number);
			end
			return args[math.random(#args)];
		else return JM_SYNTAX_ERROR;
		end
	end
end

function JM_ScanMounts()
	local landMounts = {};
	local flyingMounts = {};
	local nbMounts = GetNumCompanions("MOUNT");
	
	for i = 1,nbMounts do
		if JM_IsFlyable(i) then table.insert(flyingMounts,i);
		else table.insert(landMounts,i);
		end
	end
	
	return landMounts, flyingMounts;
end

function JM_IsFlyable(mountNum)
	local _, _, spellID, _, _ = GetCompanionInfo("MOUNT", mountNum);
	local link = GetSpellLink(spellID);
	CreateFrame("GameTooltip", "JejeMountTooltip", UIParent, "GameTooltipTemplate");
	GameTooltip_SetDefaultAnchor(JejeMountTooltip, UIParent);
	JejeMountTooltip:SetHyperlink(link);
	local text = _G["JejeMountTooltipTextLeft" .. 3]:GetText();
	JejeMountTooltip:Hide();
	if strfind(text, JM_OUTLAND) then return true;
	else return false;
	end
end

function JM_Mount(landMount, flyingMount)	
	if IsMounted() then 
		Dismount();
	else
		if IsFlyableArea() then
			local zone = GetZoneText();
			if (zone==JM_DALARAN or zone==JM_WINTERGRASP) and GetSubZoneText()~=JM_KRASUS_LANDING then
				CallCompanion("MOUNT", landMount);
			else
				CallCompanion("MOUNT", flyingMount);
			end
		else
			CallCompanion("MOUNT", landMount);
		end
	end
end
